// components/ml/mojom/ml_service.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_ML_MOJOM_ML_SERVICE_MOJOM_BLINK_H_
#define COMPONENTS_ML_MOJOM_ML_SERVICE_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "components/ml/mojom/ml_service.mojom-shared.h"
#include "components/ml/mojom/ml_service.mojom-blink-forward.h"
#include "components/ml/mojom/web_platform_model.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace ml {
namespace model_loader {
namespace mojom {
namespace blink {

class MLServiceProxy;

template <typename ImplRefTraits>
class MLServiceStub;

class MLServiceRequestValidator;
class MLServiceResponseValidator;


class MLService
    : public MLServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = MLServiceInterfaceBase;
  using Proxy_ = MLServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = MLServiceStub<ImplRefTraits>;

  using RequestValidator_ = MLServiceRequestValidator;
  using ResponseValidator_ = MLServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateModelLoaderMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CreateModelLoader_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~MLService() = default;


  using CreateModelLoaderCallback = base::OnceCallback<void(::ml::model_loader::mojom::blink::CreateModelLoaderResult, ::mojo::PendingRemote<::ml::model_loader::mojom::blink::ModelLoader>)>;
  
  virtual void CreateModelLoader(::ml::model_loader::mojom::blink::CreateModelLoaderOptionsPtr options, CreateModelLoaderCallback callback) = 0;
};



class  MLServiceProxy
    : public MLService {
 public:
  using InterfaceType = MLService;

  explicit MLServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateModelLoader(::ml::model_loader::mojom::blink::CreateModelLoaderOptionsPtr options, CreateModelLoaderCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  MLServiceStubDispatch {
 public:
  static bool Accept(MLService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      MLService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<MLService>>
class MLServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  MLServiceStub() = default;
  ~MLServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MLServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MLServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  MLServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  MLServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace blink
}  // namespace mojom
}  // namespace model_loader
}  // namespace ml

namespace mojo {

}  // namespace mojo

#endif  // COMPONENTS_ML_MOJOM_ML_SERVICE_MOJOM_BLINK_H_