// media/mojo/mojom/watch_time_recorder.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_MOJOM_WATCH_TIME_RECORDER_MOJOM_SHARED_H_
#define MEDIA_MOJO_MOJOM_WATCH_TIME_RECORDER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "media/mojo/mojom/watch_time_recorder.mojom-shared-internal.h"
#include "media/mojo/mojom/media_types.mojom-shared.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"




namespace media {
namespace mojom {
class PlaybackPropertiesDataView;

class SecondaryPlaybackPropertiesDataView;



}  // namespace mojom
}  // namespace media

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::media::mojom::PlaybackPropertiesDataView> {
  using Data = ::media::mojom::internal::PlaybackProperties_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::media::mojom::SecondaryPlaybackPropertiesDataView> {
  using Data = ::media::mojom::internal::SecondaryPlaybackProperties_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace media {
namespace mojom {
// Interface base classes. They are used for type safety check.
class WatchTimeRecorderInterfaceBase {};

using WatchTimeRecorderPtrDataView =
    mojo::InterfacePtrDataView<WatchTimeRecorderInterfaceBase>;
using WatchTimeRecorderRequestDataView =
    mojo::InterfaceRequestDataView<WatchTimeRecorderInterfaceBase>;
using WatchTimeRecorderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WatchTimeRecorderInterfaceBase>;
using WatchTimeRecorderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WatchTimeRecorderInterfaceBase>;


class PlaybackPropertiesDataView {
 public:
  PlaybackPropertiesDataView() = default;

  PlaybackPropertiesDataView(
      internal::PlaybackProperties_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool has_audio() const {
    return data_->has_audio;
  }
  bool has_video() const {
    return data_->has_video;
  }
  bool is_background() const {
    return data_->is_background;
  }
  bool is_muted() const {
    return data_->is_muted;
  }
  bool is_mse() const {
    return data_->is_mse;
  }
  bool is_eme() const {
    return data_->is_eme;
  }
  bool is_embedded_media_experience() const {
    return data_->is_embedded_media_experience;
  }
  template <typename UserType>
  [[nodiscard]] bool ReadMediaStreamType(UserType* output) const {
    auto data_value = data_->media_stream_type;
    return mojo::internal::Deserialize<::media::mojom::MediaStreamType>(
        data_value, output);
  }
  ::media::mojom::MediaStreamType media_stream_type() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::media::mojom::MediaStreamType>(data_->media_stream_type));
  }
 private:
  internal::PlaybackProperties_Data* data_ = nullptr;
};



class SecondaryPlaybackPropertiesDataView {
 public:
  SecondaryPlaybackPropertiesDataView() = default;

  SecondaryPlaybackPropertiesDataView(
      internal::SecondaryPlaybackProperties_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  [[nodiscard]] bool ReadAudioCodec(UserType* output) const {
    auto data_value = data_->audio_codec;
    return mojo::internal::Deserialize<::media::mojom::AudioCodec>(
        data_value, output);
  }
  ::media::mojom::AudioCodec audio_codec() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::media::mojom::AudioCodec>(data_->audio_codec));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadVideoCodec(UserType* output) const {
    auto data_value = data_->video_codec;
    return mojo::internal::Deserialize<::media::mojom::VideoCodec>(
        data_value, output);
  }
  ::media::mojom::VideoCodec video_codec() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::media::mojom::VideoCodec>(data_->video_codec));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadAudioCodecProfile(UserType* output) const {
    auto data_value = data_->audio_codec_profile;
    return mojo::internal::Deserialize<::media::mojom::AudioCodecProfile>(
        data_value, output);
  }
  ::media::mojom::AudioCodecProfile audio_codec_profile() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::media::mojom::AudioCodecProfile>(data_->audio_codec_profile));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadVideoCodecProfile(UserType* output) const {
    auto data_value = data_->video_codec_profile;
    return mojo::internal::Deserialize<::media::mojom::VideoCodecProfile>(
        data_value, output);
  }
  ::media::mojom::VideoCodecProfile video_codec_profile() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::media::mojom::VideoCodecProfile>(data_->video_codec_profile));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadAudioDecoder(UserType* output) const {
    auto data_value = data_->audio_decoder;
    return mojo::internal::Deserialize<::media::mojom::AudioDecoderType>(
        data_value, output);
  }
  ::media::mojom::AudioDecoderType audio_decoder() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::media::mojom::AudioDecoderType>(data_->audio_decoder));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadVideoDecoder(UserType* output) const {
    auto data_value = data_->video_decoder;
    return mojo::internal::Deserialize<::media::mojom::VideoDecoderType>(
        data_value, output);
  }
  ::media::mojom::VideoDecoderType video_decoder() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::media::mojom::VideoDecoderType>(data_->video_decoder));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadAudioEncryptionScheme(UserType* output) const {
    auto data_value = data_->audio_encryption_scheme;
    return mojo::internal::Deserialize<::media::mojom::EncryptionScheme>(
        data_value, output);
  }
  ::media::mojom::EncryptionScheme audio_encryption_scheme() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::media::mojom::EncryptionScheme>(data_->audio_encryption_scheme));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadVideoEncryptionScheme(UserType* output) const {
    auto data_value = data_->video_encryption_scheme;
    return mojo::internal::Deserialize<::media::mojom::EncryptionScheme>(
        data_value, output);
  }
  ::media::mojom::EncryptionScheme video_encryption_scheme() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::media::mojom::EncryptionScheme>(data_->video_encryption_scheme));
  }
  inline void GetNaturalSizeDataView(
      ::gfx::mojom::SizeDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadNaturalSize(UserType* output) {
    
    auto* pointer = data_->natural_size.Get();
    return mojo::internal::Deserialize<::gfx::mojom::SizeDataView>(
        pointer, output, message_);
  }
 private:
  internal::SecondaryPlaybackProperties_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace media

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media::mojom::PlaybackPropertiesDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media::mojom::PlaybackPropertiesDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::media::mojom::internal::PlaybackProperties_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->has_audio = Traits::has_audio(input);
    fragment->has_video = Traits::has_video(input);
    fragment->is_background = Traits::is_background(input);
    fragment->is_muted = Traits::is_muted(input);
    fragment->is_mse = Traits::is_mse(input);
    fragment->is_eme = Traits::is_eme(input);
    fragment->is_embedded_media_experience = Traits::is_embedded_media_experience(input);
    mojo::internal::Serialize<::media::mojom::MediaStreamType>(
        Traits::media_stream_type(input), &fragment->media_stream_type);
  }

  static bool Deserialize(::media::mojom::internal::PlaybackProperties_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media::mojom::PlaybackPropertiesDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media::mojom::SecondaryPlaybackPropertiesDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media::mojom::SecondaryPlaybackPropertiesDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::media::mojom::internal::SecondaryPlaybackProperties_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    mojo::internal::Serialize<::media::mojom::AudioCodec>(
        Traits::audio_codec(input), &fragment->audio_codec);
    mojo::internal::Serialize<::media::mojom::VideoCodec>(
        Traits::video_codec(input), &fragment->video_codec);
    mojo::internal::Serialize<::media::mojom::AudioCodecProfile>(
        Traits::audio_codec_profile(input), &fragment->audio_codec_profile);
    mojo::internal::Serialize<::media::mojom::VideoCodecProfile>(
        Traits::video_codec_profile(input), &fragment->video_codec_profile);
    mojo::internal::Serialize<::media::mojom::AudioDecoderType>(
        Traits::audio_decoder(input), &fragment->audio_decoder);
    mojo::internal::Serialize<::media::mojom::VideoDecoderType>(
        Traits::video_decoder(input), &fragment->video_decoder);
    mojo::internal::Serialize<::media::mojom::EncryptionScheme>(
        Traits::audio_encryption_scheme(input), &fragment->audio_encryption_scheme);
    mojo::internal::Serialize<::media::mojom::EncryptionScheme>(
        Traits::video_encryption_scheme(input), &fragment->video_encryption_scheme);
    decltype(Traits::natural_size(input)) in_natural_size = Traits::natural_size(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->natural_size)::BaseType> natural_size_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
        in_natural_size, natural_size_fragment);
    fragment->natural_size.Set(
        natural_size_fragment.is_null() ? nullptr : natural_size_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->natural_size.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null natural_size in SecondaryPlaybackProperties struct");
  }

  static bool Deserialize(::media::mojom::internal::SecondaryPlaybackProperties_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media::mojom::SecondaryPlaybackPropertiesDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace media {
namespace mojom {



inline void SecondaryPlaybackPropertiesDataView::GetNaturalSizeDataView(
    ::gfx::mojom::SizeDataView* output) {
  auto pointer = data_->natural_size.Get();
  *output = ::gfx::mojom::SizeDataView(pointer, message_);
}



}  // namespace mojom
}  // namespace media

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // MEDIA_MOJO_MOJOM_WATCH_TIME_RECORDER_MOJOM_SHARED_H_