// services/network/public/mojom/restricted_udp_socket.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_RESTRICTED_UDP_SOCKET_MOJOM_BLINK_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_RESTRICTED_UDP_SOCKET_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/restricted_udp_socket.mojom-shared.h"
#include "services/network/public/mojom/restricted_udp_socket.mojom-blink-forward.h"
#include "mojo/public/mojom/base/read_only_buffer.mojom-blink.h"
#include "services/network/public/mojom/network_param.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/platform/web_common.h"




namespace WTF {
template <>
struct HashTraits<::network::mojom::RestrictedUDPSocketMode>
    : EnumHashTraits<::network::mojom::RestrictedUDPSocketMode, -1000000, -1000001> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
};
}  // namespace WTF


namespace network {
namespace mojom {
namespace blink {

class RestrictedUDPSocketProxy;

template <typename ImplRefTraits>
class RestrictedUDPSocketStub;

class RestrictedUDPSocketRequestValidator;
class RestrictedUDPSocketResponseValidator;


class BLINK_PLATFORM_EXPORT RestrictedUDPSocket
    : public RestrictedUDPSocketInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = RestrictedUDPSocketInterfaceBase;
  using Proxy_ = RestrictedUDPSocketProxy;

  template <typename ImplRefTraits>
  using Stub_ = RestrictedUDPSocketStub<ImplRefTraits>;

  using RequestValidator_ = RestrictedUDPSocketRequestValidator;
  using ResponseValidator_ = RestrictedUDPSocketResponseValidator;
  enum MethodMinVersions : uint32_t {
    kReceiveMoreMinVersion = 0,
    kSendMinVersion = 0,
    kSendToMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct ReceiveMore_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Send_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct SendTo_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~RestrictedUDPSocket() = default;

  
  virtual void ReceiveMore(uint32_t num_additional_datagrams) = 0;


  using SendCallback = base::OnceCallback<void(int32_t)>;
  
  virtual void Send(::base::span<const ::uint8_t> data, SendCallback callback) = 0;


  using SendToCallback = base::OnceCallback<void(int32_t)>;
  
  virtual void SendTo(::base::span<const ::uint8_t> data, const ::net::HostPortPair& dest_addr, SendToCallback callback) = 0;
};



class BLINK_PLATFORM_EXPORT RestrictedUDPSocketProxy
    : public RestrictedUDPSocket {
 public:
  using InterfaceType = RestrictedUDPSocket;

  explicit RestrictedUDPSocketProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void ReceiveMore(uint32_t num_additional_datagrams) final;
  
  void Send(::base::span<const ::uint8_t> data, SendCallback callback) final;
  
  void SendTo(::base::span<const ::uint8_t> data, const ::net::HostPortPair& dest_addr, SendToCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_PLATFORM_EXPORT RestrictedUDPSocketStubDispatch {
 public:
  static bool Accept(RestrictedUDPSocket* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      RestrictedUDPSocket* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<RestrictedUDPSocket>>
class RestrictedUDPSocketStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  RestrictedUDPSocketStub() = default;
  ~RestrictedUDPSocketStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RestrictedUDPSocketStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RestrictedUDPSocketStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT RestrictedUDPSocketRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT RestrictedUDPSocketResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace blink
}  // namespace mojom
}  // namespace network

namespace mojo {

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_RESTRICTED_UDP_SOCKET_MOJOM_BLINK_H_