// Copyright 2014 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/runtime_feature_state_context.cc.tmpl
// and input files:
//   ../../../../../src/3rdparty/chromium/third_party/blink/renderer/platform/runtime_enabled_features.json5


#include "third_party/blink/public/common/runtime_feature_state/runtime_feature_state_context.h"

#include "base/containers/flat_map.h"
#include "third_party/blink/public/mojom/runtime_feature_state/runtime_feature_state.mojom-shared.h"
#include "third_party/blink/public/common/runtime_feature_state/runtime_feature_state_read_context.h"
#include "third_party/blink/public/common/storage_key/storage_key.h"

namespace blink {

void RuntimeFeatureStateContext::PopulateInitialValues() {
  // Write access implies read, so we are populating all inital values
  initial_values_.reserve(5);

  initial_values_.insert(
      {blink::mojom::RuntimeFeatureState::kDisableThirdPartyStoragePartitioning,
        false});
  initial_values_.insert(
      {blink::mojom::RuntimeFeatureState::kOriginTrialsSampleAPIBrowserReadWrite,
        false});
  initial_values_.insert(
      {blink::mojom::RuntimeFeatureState::kTestFeature,
        false});
  initial_values_.insert(
      {blink::mojom::RuntimeFeatureState::kThirdPartyCookiesUserBypass,
        false});
  initial_values_.insert(
      {blink::mojom::RuntimeFeatureState::kThirdPartyStoragePartitioning,
        false});

  // TODO(crbug.com/1377000): Specifying each starting value this way is rigid.
  // Find a more flexible way to do so.
  initial_values_
      [blink::mojom::RuntimeFeatureState::kThirdPartyStoragePartitioning] =
          StorageKey::IsThirdPartyStoragePartitioningEnabled();
}

}  // namespace blink