// third_party/blink/public/mojom/frame/back_forward_cache_controller.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_BACK_FORWARD_CACHE_CONTROLLER_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_BACK_FORWARD_CACHE_CONTROLLER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/frame/back_forward_cache_controller.mojom-shared.h"
#include "third_party/blink/public/mojom/frame/back_forward_cache_controller.mojom-forward.h"
#include "third_party/blink/public/mojom/navigation/renderer_eviction_reason.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {

class BackForwardCacheControllerHostProxy;

template <typename ImplRefTraits>
class BackForwardCacheControllerHostStub;

class BackForwardCacheControllerHostRequestValidator;


class BLINK_COMMON_EXPORT BackForwardCacheControllerHost
    : public BackForwardCacheControllerHostInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = BackForwardCacheControllerHostInterfaceBase;
  using Proxy_ = BackForwardCacheControllerHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = BackForwardCacheControllerHostStub<ImplRefTraits>;

  using RequestValidator_ = BackForwardCacheControllerHostRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kEvictFromBackForwardCacheMinVersion = 0,
    kDidChangeBackForwardCacheDisablingFeaturesMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct EvictFromBackForwardCache_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct DidChangeBackForwardCacheDisablingFeatures_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~BackForwardCacheControllerHost() = default;

  
  virtual void EvictFromBackForwardCache(::blink::mojom::RendererEvictionReason reason) = 0;

  
  virtual void DidChangeBackForwardCacheDisablingFeatures(uint64_t features_mask) = 0;
};



class BLINK_COMMON_EXPORT BackForwardCacheControllerHostProxy
    : public BackForwardCacheControllerHost {
 public:
  using InterfaceType = BackForwardCacheControllerHost;

  explicit BackForwardCacheControllerHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void EvictFromBackForwardCache(::blink::mojom::RendererEvictionReason reason) final;
  
  void DidChangeBackForwardCacheDisablingFeatures(uint64_t features_mask) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT BackForwardCacheControllerHostStubDispatch {
 public:
  static bool Accept(BackForwardCacheControllerHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      BackForwardCacheControllerHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<BackForwardCacheControllerHost>>
class BackForwardCacheControllerHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  BackForwardCacheControllerHostStub() = default;
  ~BackForwardCacheControllerHostStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BackForwardCacheControllerHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BackForwardCacheControllerHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT BackForwardCacheControllerHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_BACK_FORWARD_CACHE_CONTROLLER_MOJOM_H_