// third_party/blink/public/mojom/frame/pending_beacon.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/frame/pending_beacon.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/frame/pending_beacon.mojom-params-data.h"
namespace blink {
namespace mojom {

static NOINLINE const char* BeaconMethodToStringHelper(BeaconMethod value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case BeaconMethod::kPost:
      return "kPost";
    case BeaconMethod::kGet:
      return "kGet";
    default:
      return nullptr;
  }
}

std::string BeaconMethodToString(BeaconMethod value) {
  const char *str = BeaconMethodToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown BeaconMethod value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, BeaconMethod value) {
  return os << BeaconMethodToString(value);
}

namespace internal {


// static
bool PendingBeaconHost_CreateBeacon_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PendingBeaconHost_CreateBeacon_Params_Data* object =
      static_cast<const PendingBeaconHost_CreateBeacon_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->receiver, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->receiver,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->url, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->url, validation_context))
    return false;


  if (!::blink::mojom::internal::BeaconMethod_Data
        ::Validate(object->method, validation_context))
    return false;

  return true;
}

PendingBeaconHost_CreateBeacon_Params_Data::PendingBeaconHost_CreateBeacon_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PendingBeacon_Deactivate_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PendingBeacon_Deactivate_Params_Data* object =
      static_cast<const PendingBeacon_Deactivate_Params_Data*>(data);

  return true;
}

PendingBeacon_Deactivate_Params_Data::PendingBeacon_Deactivate_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PendingBeacon_SetRequestData_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PendingBeacon_SetRequestData_Params_Data* object =
      static_cast<const PendingBeacon_SetRequestData_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->request_body, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->request_body, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->content_type, 2, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& content_type_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->content_type, validation_context,
                                         &content_type_validate_params)) {
    return false;
  }

  return true;
}

PendingBeacon_SetRequestData_Params_Data::PendingBeacon_SetRequestData_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PendingBeacon_SetRequestURL_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PendingBeacon_SetRequestURL_Params_Data* object =
      static_cast<const PendingBeacon_SetRequestURL_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->url, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->url, validation_context))
    return false;

  return true;
}

PendingBeacon_SetRequestURL_Params_Data::PendingBeacon_SetRequestURL_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PendingBeacon_SendNow_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PendingBeacon_SendNow_Params_Data* object =
      static_cast<const PendingBeacon_SendNow_Params_Data*>(data);

  return true;
}

PendingBeacon_SendNow_Params_Data::PendingBeacon_SendNow_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::BeaconMethod>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::BeaconMethod value) {
  return std::move(context).WriteString(::blink::mojom::BeaconMethodToString(value));
}

} // namespace perfetto