// third_party/blink/public/mojom/interest_group/ad_auction_service.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/interest_group/ad_auction_service.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/interest_group/ad_auction_service.mojom-params-data.h"
namespace blink {
namespace mojom {

static NOINLINE const char* AuctionAdConfigFieldToStringHelper(AuctionAdConfigField value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case AuctionAdConfigField::kAuctionSignals:
      return "kAuctionSignals";
    case AuctionAdConfigField::kSellerSignals:
      return "kSellerSignals";
    default:
      return nullptr;
  }
}

std::string AuctionAdConfigFieldToString(AuctionAdConfigField value) {
  const char *str = AuctionAdConfigFieldToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown AuctionAdConfigField value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, AuctionAdConfigField value) {
  return os << AuctionAdConfigFieldToString(value);
}

static NOINLINE const char* AuctionAdConfigBuyerTimeoutFieldToStringHelper(AuctionAdConfigBuyerTimeoutField value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case AuctionAdConfigBuyerTimeoutField::kPerBuyerTimeouts:
      return "kPerBuyerTimeouts";
    case AuctionAdConfigBuyerTimeoutField::kPerBuyerCumulativeTimeouts:
      return "kPerBuyerCumulativeTimeouts";
    default:
      return nullptr;
  }
}

std::string AuctionAdConfigBuyerTimeoutFieldToString(AuctionAdConfigBuyerTimeoutField value) {
  const char *str = AuctionAdConfigBuyerTimeoutFieldToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown AuctionAdConfigBuyerTimeoutField value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, AuctionAdConfigBuyerTimeoutField value) {
  return os << AuctionAdConfigBuyerTimeoutFieldToString(value);
}

namespace internal {
// static
bool AuctionAdConfigAuctionId_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context,
    bool inlined) {
  if (!data) {
    DCHECK(!inlined);
    return true;
  }

  // If it is inlined, the alignment is already enforced by its enclosing
  // object. We don't have to validate that.
  DCHECK(!inlined || mojo::internal::IsAligned(data));

  if (!inlined &&
      !mojo::internal::ValidateNonInlinedUnionHeaderAndClaimMemory(
          data, validation_context)) {
    return false;
  }

  const AuctionAdConfigAuctionId_Data* object = static_cast<const AuctionAdConfigAuctionId_Data*>(data);

  if (inlined && object->is_null())
    return true;

  switch (object->tag) {

    case AuctionAdConfigAuctionId_Tag::kMainAuction: {

      return true;
    }
    case AuctionAdConfigAuctionId_Tag::kComponentAuction: {

      return true;
    }
    default: {

      ReportValidationError(
          validation_context,
          mojo::internal::VALIDATION_ERROR_UNKNOWN_UNION_TAG,
          "unknown tag in AuctionAdConfigAuctionId");
      return false;
    }
  }
}


// static
bool AdKeywordReplacement_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdKeywordReplacement_Data* object =
      static_cast<const AdKeywordReplacement_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->match, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& match_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->match, validation_context,
                                         &match_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->replacement, 2, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& replacement_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->replacement, validation_context,
                                         &replacement_validate_params)) {
    return false;
  }

  return true;
}

AdKeywordReplacement_Data::AdKeywordReplacement_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AbortableAdAuction_ResolvedPromiseParam_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 40, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AbortableAdAuction_ResolvedPromiseParam_Params_Data* object =
      static_cast<const AbortableAdAuction_ResolvedPromiseParam_Params_Data*>(data);

  if (!mojo::internal::ValidateInlinedUnionNonNullable(
          object->auction, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateInlinedUnion(object->auction, validation_context))
    return false;


  if (!::blink::mojom::internal::AuctionAdConfigField_Data
        ::Validate(object->field, validation_context))
    return false;

  constexpr const mojo::internal::ContainerValidateParams& json_value_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->json_value, validation_context,
                                         &json_value_validate_params)) {
    return false;
  }

  return true;
}

AbortableAdAuction_ResolvedPromiseParam_Params_Data::AbortableAdAuction_ResolvedPromiseParam_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AbortableAdAuction_ResolvedPerBuyerSignalsPromise_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AbortableAdAuction_ResolvedPerBuyerSignalsPromise_Params_Data* object =
      static_cast<const AbortableAdAuction_ResolvedPerBuyerSignalsPromise_Params_Data*>(data);

  if (!mojo::internal::ValidateInlinedUnionNonNullable(
          object->auction, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateInlinedUnion(object->auction, validation_context))
    return false;

  constexpr const mojo::internal::ContainerValidateParams& per_buyer_signals_validate_params =
      mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, nullptr>(), *&mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>()>();
  if (!mojo::internal::ValidateContainer(object->per_buyer_signals, validation_context,
                                         &per_buyer_signals_validate_params)) {
    return false;
  }

  return true;
}

AbortableAdAuction_ResolvedPerBuyerSignalsPromise_Params_Data::AbortableAdAuction_ResolvedPerBuyerSignalsPromise_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AbortableAdAuction_ResolvedBuyerTimeoutsPromise_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 40, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AbortableAdAuction_ResolvedBuyerTimeoutsPromise_Params_Data* object =
      static_cast<const AbortableAdAuction_ResolvedBuyerTimeoutsPromise_Params_Data*>(data);

  if (!mojo::internal::ValidateInlinedUnionNonNullable(
          object->auction, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateInlinedUnion(object->auction, validation_context))
    return false;


  if (!::blink::mojom::internal::AuctionAdConfigBuyerTimeoutField_Data
        ::Validate(object->field, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->buyer_timeouts, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->buyer_timeouts, validation_context))
    return false;

  return true;
}

AbortableAdAuction_ResolvedBuyerTimeoutsPromise_Params_Data::AbortableAdAuction_ResolvedBuyerTimeoutsPromise_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AbortableAdAuction_ResolvedDirectFromSellerSignalsPromise_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AbortableAdAuction_ResolvedDirectFromSellerSignalsPromise_Params_Data* object =
      static_cast<const AbortableAdAuction_ResolvedDirectFromSellerSignalsPromise_Params_Data*>(data);

  if (!mojo::internal::ValidateInlinedUnionNonNullable(
          object->auction, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateInlinedUnion(object->auction, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->direct_from_seller_signals, validation_context))
    return false;

  return true;
}

AbortableAdAuction_ResolvedDirectFromSellerSignalsPromise_Params_Data::AbortableAdAuction_ResolvedDirectFromSellerSignalsPromise_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AbortableAdAuction_Abort_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AbortableAdAuction_Abort_Params_Data* object =
      static_cast<const AbortableAdAuction_Abort_Params_Data*>(data);

  return true;
}

AbortableAdAuction_Abort_Params_Data::AbortableAdAuction_Abort_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_CreateAdRequest_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_CreateAdRequest_Params_Data* object =
      static_cast<const AdAuctionService_CreateAdRequest_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->config, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->config, validation_context))
    return false;

  return true;
}

AdAuctionService_CreateAdRequest_Params_Data::AdAuctionService_CreateAdRequest_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_CreateAdRequest_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_CreateAdRequest_ResponseParams_Data* object =
      static_cast<const AdAuctionService_CreateAdRequest_ResponseParams_Data*>(data);

  constexpr const mojo::internal::ContainerValidateParams& ads_guid_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->ads_guid, validation_context,
                                         &ads_guid_validate_params)) {
    return false;
  }

  return true;
}

AdAuctionService_CreateAdRequest_ResponseParams_Data::AdAuctionService_CreateAdRequest_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_FinalizeAd_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_FinalizeAd_Params_Data* object =
      static_cast<const AdAuctionService_FinalizeAd_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->ads_guid, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& ads_guid_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->ads_guid, validation_context,
                                         &ads_guid_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->config, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->config, validation_context))
    return false;

  return true;
}

AdAuctionService_FinalizeAd_Params_Data::AdAuctionService_FinalizeAd_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_FinalizeAd_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_FinalizeAd_ResponseParams_Data* object =
      static_cast<const AdAuctionService_FinalizeAd_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->ad_display_url, validation_context))
    return false;

  return true;
}

AdAuctionService_FinalizeAd_ResponseParams_Data::AdAuctionService_FinalizeAd_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_RunAdAuction_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_RunAdAuction_Params_Data* object =
      static_cast<const AdAuctionService_RunAdAuction_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->config, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->config, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterface(object->abort_receiver,
                                                 validation_context)) {
    return false;
  }

  return true;
}

AdAuctionService_RunAdAuction_Params_Data::AdAuctionService_RunAdAuction_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_RunAdAuction_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_RunAdAuction_ResponseParams_Data* object =
      static_cast<const AdAuctionService_RunAdAuction_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->config, validation_context))
    return false;

  return true;
}

AdAuctionService_RunAdAuction_ResponseParams_Data::AdAuctionService_RunAdAuction_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_JoinInterestGroup_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_JoinInterestGroup_Params_Data* object =
      static_cast<const AdAuctionService_JoinInterestGroup_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->group, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->group, validation_context))
    return false;

  return true;
}

AdAuctionService_JoinInterestGroup_Params_Data::AdAuctionService_JoinInterestGroup_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_JoinInterestGroup_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_JoinInterestGroup_ResponseParams_Data* object =
      static_cast<const AdAuctionService_JoinInterestGroup_ResponseParams_Data*>(data);

  return true;
}

AdAuctionService_JoinInterestGroup_ResponseParams_Data::AdAuctionService_JoinInterestGroup_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_LeaveInterestGroup_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_LeaveInterestGroup_Params_Data* object =
      static_cast<const AdAuctionService_LeaveInterestGroup_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->owner, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->owner, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->name, 2, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& name_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->name, validation_context,
                                         &name_validate_params)) {
    return false;
  }

  return true;
}

AdAuctionService_LeaveInterestGroup_Params_Data::AdAuctionService_LeaveInterestGroup_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_LeaveInterestGroup_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_LeaveInterestGroup_ResponseParams_Data* object =
      static_cast<const AdAuctionService_LeaveInterestGroup_ResponseParams_Data*>(data);

  return true;
}

AdAuctionService_LeaveInterestGroup_ResponseParams_Data::AdAuctionService_LeaveInterestGroup_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_LeaveInterestGroupForDocument_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_LeaveInterestGroupForDocument_Params_Data* object =
      static_cast<const AdAuctionService_LeaveInterestGroupForDocument_Params_Data*>(data);

  return true;
}

AdAuctionService_LeaveInterestGroupForDocument_Params_Data::AdAuctionService_LeaveInterestGroupForDocument_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_UpdateAdInterestGroups_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_UpdateAdInterestGroups_Params_Data* object =
      static_cast<const AdAuctionService_UpdateAdInterestGroups_Params_Data*>(data);

  return true;
}

AdAuctionService_UpdateAdInterestGroups_Params_Data::AdAuctionService_UpdateAdInterestGroups_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_DeprecatedGetURLFromURN_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_DeprecatedGetURLFromURN_Params_Data* object =
      static_cast<const AdAuctionService_DeprecatedGetURLFromURN_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->uuid_url, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->uuid_url, validation_context))
    return false;

  return true;
}

AdAuctionService_DeprecatedGetURLFromURN_Params_Data::AdAuctionService_DeprecatedGetURLFromURN_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_DeprecatedGetURLFromURN_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_DeprecatedGetURLFromURN_ResponseParams_Data* object =
      static_cast<const AdAuctionService_DeprecatedGetURLFromURN_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->decoded_url, validation_context))
    return false;

  return true;
}

AdAuctionService_DeprecatedGetURLFromURN_ResponseParams_Data::AdAuctionService_DeprecatedGetURLFromURN_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_DeprecatedReplaceInURN_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_DeprecatedReplaceInURN_Params_Data* object =
      static_cast<const AdAuctionService_DeprecatedReplaceInURN_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->uuid_url, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->uuid_url, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->replacements, 2, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& replacements_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->replacements, validation_context,
                                         &replacements_validate_params)) {
    return false;
  }

  return true;
}

AdAuctionService_DeprecatedReplaceInURN_Params_Data::AdAuctionService_DeprecatedReplaceInURN_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AdAuctionService_DeprecatedReplaceInURN_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdAuctionService_DeprecatedReplaceInURN_ResponseParams_Data* object =
      static_cast<const AdAuctionService_DeprecatedReplaceInURN_ResponseParams_Data*>(data);

  return true;
}

AdAuctionService_DeprecatedReplaceInURN_ResponseParams_Data::AdAuctionService_DeprecatedReplaceInURN_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::AuctionAdConfigField>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::AuctionAdConfigField value) {
  return std::move(context).WriteString(::blink::mojom::AuctionAdConfigFieldToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::AuctionAdConfigBuyerTimeoutField>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::AuctionAdConfigBuyerTimeoutField value) {
  return std::move(context).WriteString(::blink::mojom::AuctionAdConfigBuyerTimeoutFieldToString(value));
}

} // namespace perfetto