// third_party/blink/public/mojom/smart_card/smart_card.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/smart_card/smart_card.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/smart_card/smart_card.mojom-params-data.h"
namespace blink {
namespace mojom {

static NOINLINE const char* SmartCardResponseCodeToStringHelper(SmartCardResponseCode value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case SmartCardResponseCode::kNoService:
      return "kNoService";
    case SmartCardResponseCode::kNoSmartCard:
      return "kNoSmartCard";
    case SmartCardResponseCode::kNotReady:
      return "kNotReady";
    case SmartCardResponseCode::kNotTransacted:
      return "kNotTransacted";
    case SmartCardResponseCode::kProtoMismatch:
      return "kProtoMismatch";
    case SmartCardResponseCode::kReaderUnavailable:
      return "kReaderUnavailable";
    case SmartCardResponseCode::kRemovedCard:
      return "kRemovedCard";
    case SmartCardResponseCode::kResetCard:
      return "kResetCard";
    case SmartCardResponseCode::kSharingViolation:
      return "kSharingViolation";
    case SmartCardResponseCode::kSystemCancelled:
      return "kSystemCancelled";
    case SmartCardResponseCode::kUnpoweredCard:
      return "kUnpoweredCard";
    case SmartCardResponseCode::kUnresponsiveCard:
      return "kUnresponsiveCard";
    case SmartCardResponseCode::kUnsupportedCard:
      return "kUnsupportedCard";
    case SmartCardResponseCode::kUnsupportedFeature:
      return "kUnsupportedFeature";
    default:
      return nullptr;
  }
}

std::string SmartCardResponseCodeToString(SmartCardResponseCode value) {
  const char *str = SmartCardResponseCodeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown SmartCardResponseCode value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, SmartCardResponseCode value) {
  return os << SmartCardResponseCodeToString(value);
}

static NOINLINE const char* SmartCardReaderStateToStringHelper(SmartCardReaderState value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case SmartCardReaderState::kUnavailable:
      return "kUnavailable";
    case SmartCardReaderState::kEmpty:
      return "kEmpty";
    case SmartCardReaderState::kPresent:
      return "kPresent";
    case SmartCardReaderState::kExclusive:
      return "kExclusive";
    case SmartCardReaderState::kInuse:
      return "kInuse";
    case SmartCardReaderState::kMute:
      return "kMute";
    case SmartCardReaderState::kUnpowered:
      return "kUnpowered";
    default:
      return nullptr;
  }
}

std::string SmartCardReaderStateToString(SmartCardReaderState value) {
  const char *str = SmartCardReaderStateToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown SmartCardReaderState value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, SmartCardReaderState value) {
  return os << SmartCardReaderStateToString(value);
}

namespace internal {
// static
bool SmartCardGetReadersResult_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context,
    bool inlined) {
  if (!data) {
    DCHECK(!inlined);
    return true;
  }

  // If it is inlined, the alignment is already enforced by its enclosing
  // object. We don't have to validate that.
  DCHECK(!inlined || mojo::internal::IsAligned(data));

  if (!inlined &&
      !mojo::internal::ValidateNonInlinedUnionHeaderAndClaimMemory(
          data, validation_context)) {
    return false;
  }

  const SmartCardGetReadersResult_Data* object = static_cast<const SmartCardGetReadersResult_Data*>(data);

  if (inlined && object->is_null())
    return true;

  switch (object->tag) {

    case SmartCardGetReadersResult_Tag::kResponseCode: {


      if (!::blink::mojom::internal::SmartCardResponseCode_Data
            ::Validate(object->data.f_response_code, validation_context))
        return false;
      return true;
    }
    case SmartCardGetReadersResult_Tag::kReaders: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_readers, 2, validation_context)) {
        return false;
      }
      constexpr const mojo::internal::ContainerValidateParams& readers_validate_params =
          mojo::internal::GetArrayValidator<0, false, nullptr>();
      if (!mojo::internal::ValidateContainer(object->data.f_readers, validation_context,
                                             &readers_validate_params)) {
        return false;
      }
      return true;
    }
    default: {

      ReportValidationError(
          validation_context,
          mojo::internal::VALIDATION_ERROR_UNKNOWN_UNION_TAG,
          "unknown tag in SmartCardGetReadersResult");
      return false;
    }
  }
}


// static
bool SmartCardReaderInfo_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SmartCardReaderInfo_Data* object =
      static_cast<const SmartCardReaderInfo_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->name, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& name_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->name, validation_context,
                                         &name_validate_params)) {
    return false;
  }


  if (!::blink::mojom::internal::SmartCardReaderState_Data
        ::Validate(object->state, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->atr, 3, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& atr_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->atr, validation_context,
                                         &atr_validate_params)) {
    return false;
  }

  return true;
}

SmartCardReaderInfo_Data::SmartCardReaderInfo_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SmartCardServiceClient_ReaderAdded_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SmartCardServiceClient_ReaderAdded_Params_Data* object =
      static_cast<const SmartCardServiceClient_ReaderAdded_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->reader_info, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->reader_info, validation_context))
    return false;

  return true;
}

SmartCardServiceClient_ReaderAdded_Params_Data::SmartCardServiceClient_ReaderAdded_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SmartCardServiceClient_ReaderRemoved_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SmartCardServiceClient_ReaderRemoved_Params_Data* object =
      static_cast<const SmartCardServiceClient_ReaderRemoved_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->reader_info, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->reader_info, validation_context))
    return false;

  return true;
}

SmartCardServiceClient_ReaderRemoved_Params_Data::SmartCardServiceClient_ReaderRemoved_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SmartCardServiceClient_ReaderChanged_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SmartCardServiceClient_ReaderChanged_Params_Data* object =
      static_cast<const SmartCardServiceClient_ReaderChanged_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->reader_info, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->reader_info, validation_context))
    return false;

  return true;
}

SmartCardServiceClient_ReaderChanged_Params_Data::SmartCardServiceClient_ReaderChanged_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SmartCardService_RegisterClient_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SmartCardService_RegisterClient_Params_Data* object =
      static_cast<const SmartCardService_RegisterClient_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->client, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->client,
                                                 validation_context)) {
    return false;
  }

  return true;
}

SmartCardService_RegisterClient_Params_Data::SmartCardService_RegisterClient_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SmartCardService_RegisterClient_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SmartCardService_RegisterClient_ResponseParams_Data* object =
      static_cast<const SmartCardService_RegisterClient_ResponseParams_Data*>(data);

  return true;
}

SmartCardService_RegisterClient_ResponseParams_Data::SmartCardService_RegisterClient_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SmartCardService_GetReaders_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SmartCardService_GetReaders_Params_Data* object =
      static_cast<const SmartCardService_GetReaders_Params_Data*>(data);

  return true;
}

SmartCardService_GetReaders_Params_Data::SmartCardService_GetReaders_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SmartCardService_GetReaders_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SmartCardService_GetReaders_ResponseParams_Data* object =
      static_cast<const SmartCardService_GetReaders_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateInlinedUnionNonNullable(
          object->result, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateInlinedUnion(object->result, validation_context))
    return false;

  return true;
}

SmartCardService_GetReaders_ResponseParams_Data::SmartCardService_GetReaders_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::SmartCardResponseCode>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::SmartCardResponseCode value) {
  return std::move(context).WriteString(::blink::mojom::SmartCardResponseCodeToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::SmartCardReaderState>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::SmartCardReaderState value) {
  return std::move(context).WriteString(::blink::mojom::SmartCardReaderStateToString(value));
}

} // namespace perfetto