// third_party/blink/public/mojom/smart_card/smart_card.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_SMART_CARD_SMART_CARD_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_SMART_CARD_SMART_CARD_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/smart_card/smart_card.mojom-shared.h"
#include "third_party/blink/public/mojom/smart_card/smart_card.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {

class SmartCardServiceClientProxy;

template <typename ImplRefTraits>
class SmartCardServiceClientStub;

class SmartCardServiceClientRequestValidator;


class BLINK_COMMON_EXPORT SmartCardServiceClient
    : public SmartCardServiceClientInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = SmartCardServiceClientInterfaceBase;
  using Proxy_ = SmartCardServiceClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = SmartCardServiceClientStub<ImplRefTraits>;

  using RequestValidator_ = SmartCardServiceClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kReaderAddedMinVersion = 0,
    kReaderRemovedMinVersion = 0,
    kReaderChangedMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct ReaderAdded_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct ReaderRemoved_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct ReaderChanged_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~SmartCardServiceClient() = default;

  
  virtual void ReaderAdded(SmartCardReaderInfoPtr reader_info) = 0;

  
  virtual void ReaderRemoved(SmartCardReaderInfoPtr reader_info) = 0;

  
  virtual void ReaderChanged(SmartCardReaderInfoPtr reader_info) = 0;
};

class SmartCardServiceProxy;

template <typename ImplRefTraits>
class SmartCardServiceStub;

class SmartCardServiceRequestValidator;
class SmartCardServiceResponseValidator;


class BLINK_COMMON_EXPORT SmartCardService
    : public SmartCardServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = true;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = SmartCardServiceInterfaceBase;
  using Proxy_ = SmartCardServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = SmartCardServiceStub<ImplRefTraits>;

  using RequestValidator_ = SmartCardServiceRequestValidator;
  using ResponseValidator_ = SmartCardServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kRegisterClientMinVersion = 0,
    kGetReadersMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct RegisterClient_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct GetReaders_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~SmartCardService() = default;


  using RegisterClientCallback = base::OnceCallback<void(bool)>;
  
  virtual void RegisterClient(::mojo::PendingAssociatedRemote<SmartCardServiceClient> client, RegisterClientCallback callback) = 0;


  using GetReadersCallback = base::OnceCallback<void(SmartCardGetReadersResultPtr)>;
  
  virtual void GetReaders(GetReadersCallback callback) = 0;
};



class BLINK_COMMON_EXPORT SmartCardServiceClientProxy
    : public SmartCardServiceClient {
 public:
  using InterfaceType = SmartCardServiceClient;

  explicit SmartCardServiceClientProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void ReaderAdded(SmartCardReaderInfoPtr reader_info) final;
  
  void ReaderRemoved(SmartCardReaderInfoPtr reader_info) final;
  
  void ReaderChanged(SmartCardReaderInfoPtr reader_info) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class BLINK_COMMON_EXPORT SmartCardServiceProxy
    : public SmartCardService {
 public:
  using InterfaceType = SmartCardService;

  explicit SmartCardServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void RegisterClient(::mojo::PendingAssociatedRemote<SmartCardServiceClient> client, RegisterClientCallback callback) final;
  
  void GetReaders(GetReadersCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT SmartCardServiceClientStubDispatch {
 public:
  static bool Accept(SmartCardServiceClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SmartCardServiceClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SmartCardServiceClient>>
class SmartCardServiceClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SmartCardServiceClientStub() = default;
  ~SmartCardServiceClientStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SmartCardServiceClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SmartCardServiceClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT SmartCardServiceStubDispatch {
 public:
  static bool Accept(SmartCardService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SmartCardService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SmartCardService>>
class SmartCardServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SmartCardServiceStub() = default;
  ~SmartCardServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SmartCardServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SmartCardServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT SmartCardServiceClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT SmartCardServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT SmartCardServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};






class BLINK_COMMON_EXPORT SmartCardGetReadersResult {
 public:
  using DataView = SmartCardGetReadersResultDataView;
  using Data_ = internal::SmartCardGetReadersResult_Data;
  using Tag = Data_::SmartCardGetReadersResult_Tag;

  template <typename... Args>
  static SmartCardGetReadersResultPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |response_code|.
  static SmartCardGetReadersResultPtr
  NewResponseCode(
      SmartCardResponseCode response_code) {
    auto result = SmartCardGetReadersResultPtr(absl::in_place);
    result->set_response_code(std::move(response_code));
    return result;
  }
  // Construct an instance holding |readers|.
  static SmartCardGetReadersResultPtr
  NewReaders(
      std::vector<SmartCardReaderInfoPtr> readers) {
    auto result = SmartCardGetReadersResultPtr(absl::in_place);
    result->set_readers(std::move(readers));
    return result;
  }

  template <typename U>
  static SmartCardGetReadersResultPtr From(const U& u) {
    return mojo::TypeConverter<SmartCardGetReadersResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SmartCardGetReadersResult>::Convert(*this);
  }

  SmartCardGetReadersResult();
  ~SmartCardGetReadersResult();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  SmartCardGetReadersResult(const SmartCardGetReadersResult& other) = delete;
  SmartCardGetReadersResult& operator=(const SmartCardGetReadersResult& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = SmartCardGetReadersResultPtr>
  SmartCardGetReadersResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, SmartCardGetReadersResult>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, SmartCardGetReadersResult>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_response_code() const { return tag_ == Tag::kResponseCode; }

  
  SmartCardResponseCode get_response_code() const {
    CHECK(tag_ == Tag::kResponseCode);
    return data_.response_code;
  }

  
  void set_response_code(
      SmartCardResponseCode response_code);
  
  bool is_readers() const { return tag_ == Tag::kReaders; }

  
  std::vector<SmartCardReaderInfoPtr>& get_readers() const {
    CHECK(tag_ == Tag::kReaders);
    return *(data_.readers);
  }

  
  void set_readers(
      std::vector<SmartCardReaderInfoPtr> readers);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SmartCardGetReadersResult::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<SmartCardGetReadersResult::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    SmartCardResponseCode response_code;
    std::vector<SmartCardReaderInfoPtr>* readers;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};





class BLINK_COMMON_EXPORT SmartCardReaderInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SmartCardReaderInfo, T>::value>;
  using DataView = SmartCardReaderInfoDataView;
  using Data_ = internal::SmartCardReaderInfo_Data;

  template <typename... Args>
  static SmartCardReaderInfoPtr New(Args&&... args) {
    return SmartCardReaderInfoPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SmartCardReaderInfoPtr From(const U& u) {
    return mojo::TypeConverter<SmartCardReaderInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SmartCardReaderInfo>::Convert(*this);
  }


  SmartCardReaderInfo();

  SmartCardReaderInfo(
      const std::string& name,
      SmartCardReaderState state,
      std::vector<uint8_t> atr);


  ~SmartCardReaderInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SmartCardReaderInfoPtr>
  SmartCardReaderInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SmartCardReaderInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, SmartCardReaderInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SmartCardReaderInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SmartCardReaderInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SmartCardReaderInfo_UnserializedMessageContext<
            UserType, SmartCardReaderInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<SmartCardReaderInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return SmartCardReaderInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SmartCardReaderInfo_UnserializedMessageContext<
            UserType, SmartCardReaderInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SmartCardReaderInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string name;
  
  SmartCardReaderState state;
  
  std::vector<uint8_t> atr;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SmartCardReaderInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SmartCardReaderInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SmartCardReaderInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SmartCardReaderInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename UnionPtrType>
SmartCardGetReadersResultPtr SmartCardGetReadersResult::Clone() const {
  switch (tag_) {
    case Tag::kResponseCode:
      return NewResponseCode(
          mojo::Clone(data_.response_code));
    case Tag::kReaders:
      return NewReaders(
          mojo::Clone(*data_.readers));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, SmartCardGetReadersResult>::value>::type*>
bool SmartCardGetReadersResult::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kResponseCode:
      return mojo::Equals(data_.response_code, other.data_.response_code);
    case Tag::kReaders:
      return mojo::Equals(*(data_.readers), *(other.data_.readers));
  }

  return false;
}
template <typename StructPtrType>
SmartCardReaderInfoPtr SmartCardReaderInfo::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(state),
      mojo::Clone(atr)
  );
}

template <typename T, SmartCardReaderInfo::EnableIfSame<T>*>
bool SmartCardReaderInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->state, other_struct.state))
    return false;
  if (!mojo::Equals(this->atr, other_struct.atr))
    return false;
  return true;
}

template <typename T, SmartCardReaderInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.state < rhs.state)
    return true;
  if (rhs.state < lhs.state)
    return false;
  if (lhs.atr < rhs.atr)
    return true;
  if (rhs.atr < lhs.atr)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::SmartCardReaderInfo::DataView,
                                         ::blink::mojom::SmartCardReaderInfoPtr> {
  static bool IsNull(const ::blink::mojom::SmartCardReaderInfoPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::SmartCardReaderInfoPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::SmartCardReaderInfo::name)& name(
      const ::blink::mojom::SmartCardReaderInfoPtr& input) {
    return input->name;
  }

  static decltype(::blink::mojom::SmartCardReaderInfo::state) state(
      const ::blink::mojom::SmartCardReaderInfoPtr& input) {
    return input->state;
  }

  static const decltype(::blink::mojom::SmartCardReaderInfo::atr)& atr(
      const ::blink::mojom::SmartCardReaderInfoPtr& input) {
    return input->atr;
  }

  static bool Read(::blink::mojom::SmartCardReaderInfo::DataView input, ::blink::mojom::SmartCardReaderInfoPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT UnionTraits<::blink::mojom::SmartCardGetReadersResult::DataView,
                                        ::blink::mojom::SmartCardGetReadersResultPtr> {
  static bool IsNull(const ::blink::mojom::SmartCardGetReadersResultPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::SmartCardGetReadersResultPtr* output) { output->reset(); }

  static ::blink::mojom::SmartCardGetReadersResult::Tag GetTag(const ::blink::mojom::SmartCardGetReadersResultPtr& input) {
    return input->which();
  }

  static  ::blink::mojom::SmartCardResponseCode response_code(const ::blink::mojom::SmartCardGetReadersResultPtr& input) {
    return input->get_response_code();
  }

  static const std::vector<::blink::mojom::SmartCardReaderInfoPtr>& readers(const ::blink::mojom::SmartCardGetReadersResultPtr& input) {
    return input->get_readers();
  }

  static bool Read(::blink::mojom::SmartCardGetReadersResult::DataView input, ::blink::mojom::SmartCardGetReadersResultPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_SMART_CARD_SMART_CARD_MOJOM_H_