// This is generated file. Do not modify directly.

#include "third_party/blink/renderer/modules/mediarecorder/openh264_stubs.h"

#include <dlfcn.h>   // For dlsym, dlopen, RTLD_LAZY.

#include <cstdarg>

#include "base/compiler_specific.h"
#include "base/logging.h"

// The extra include header needed in the generated stub file for defining
// various OpenH264 types.

extern "C" {

#include "third_party/openh264/src/codec/api/wels/codec_api.h"
#include "third_party/openh264/src/codec/api/wels/codec_app_def.h"
#include "third_party/openh264/src/codec/api/wels/codec_def.h"
#include "third_party/openh264/src/codec/api/wels/codec_ver.h"

}

namespace  {

void LogDlerror(const char* symbol) {
  VLOG(1) << "Couldn't load " << symbol << ", dlerror() says:\n" << dlerror();
}

}  // namespace 

extern "C" {

// Static pointers that will hold the location of the real function
// implementations after the module has been loaded.
static int (*WelsCreateSVCEncoder_ptr)(ISVCEncoder **ppEncoder) = nullptr;
static void (*WelsDestroySVCEncoder_ptr)(ISVCEncoder *pEncoder) = nullptr;
static int (*WelsGetDecoderCapability_ptr)(SDecoderCapability *pDecCapability) = nullptr;
static long (*WelsCreateDecoder_ptr)(ISVCDecoder **ppDecoder) = nullptr;
static void (*WelsDestroyDecoder_ptr)(ISVCDecoder *pDecoder) = nullptr;
static OpenH264Version (*WelsGetCodecVersion_ptr)(void) = nullptr;
static void (*WelsGetCodecVersionEx_ptr)(OpenH264Version *pVersion) = nullptr;

// Stubs that dispatch to the real implementations.
extern int WelsCreateSVCEncoder(ISVCEncoder **ppEncoder) __attribute__((weak));
DISABLE_CFI_ICALL
int  WelsCreateSVCEncoder(ISVCEncoder **ppEncoder) {
  return WelsCreateSVCEncoder_ptr(ppEncoder);
}
extern void WelsDestroySVCEncoder(ISVCEncoder *pEncoder) __attribute__((weak));
DISABLE_CFI_ICALL
void  WelsDestroySVCEncoder(ISVCEncoder *pEncoder) {
  WelsDestroySVCEncoder_ptr(pEncoder);
}
extern int WelsGetDecoderCapability(SDecoderCapability *pDecCapability) __attribute__((weak));
DISABLE_CFI_ICALL
int  WelsGetDecoderCapability(SDecoderCapability *pDecCapability) {
  return WelsGetDecoderCapability_ptr(pDecCapability);
}
extern long WelsCreateDecoder(ISVCDecoder **ppDecoder) __attribute__((weak));
DISABLE_CFI_ICALL
long  WelsCreateDecoder(ISVCDecoder **ppDecoder) {
  return WelsCreateDecoder_ptr(ppDecoder);
}
extern void WelsDestroyDecoder(ISVCDecoder *pDecoder) __attribute__((weak));
DISABLE_CFI_ICALL
void  WelsDestroyDecoder(ISVCDecoder *pDecoder) {
  WelsDestroyDecoder_ptr(pDecoder);
}
extern OpenH264Version WelsGetCodecVersion(void) __attribute__((weak));
DISABLE_CFI_ICALL
OpenH264Version  WelsGetCodecVersion(void) {
  return WelsGetCodecVersion_ptr();
}
extern void WelsGetCodecVersionEx(OpenH264Version *pVersion) __attribute__((weak));
DISABLE_CFI_ICALL
void  WelsGetCodecVersionEx(OpenH264Version *pVersion) {
  WelsGetCodecVersionEx_ptr(pVersion);
}

}  // extern "C"


namespace third_party_blink_renderer_modules_mediarecorder {

// Returns true if all stubs have been properly initialized.
bool IsOpenh264Initialized() {
  return WelsCreateSVCEncoder_ptr &&
         WelsDestroySVCEncoder_ptr &&
         WelsGetDecoderCapability_ptr &&
         WelsCreateDecoder_ptr &&
         WelsDestroyDecoder_ptr &&
         WelsGetCodecVersion_ptr &&
         WelsGetCodecVersionEx_ptr;
}

// Initializes the module stubs.
void InitializeOpenh264(void* module) {
  const char WelsCreateSVCEncoder_name[] = "WelsCreateSVCEncoder";
  WelsCreateSVCEncoder_ptr =
    reinterpret_cast<int (*)(ISVCEncoder **ppEncoder)>(
      dlsym(module, WelsCreateSVCEncoder_name));
  if (!WelsCreateSVCEncoder_ptr)
    LogDlerror(WelsCreateSVCEncoder_name);
  const char WelsDestroySVCEncoder_name[] = "WelsDestroySVCEncoder";
  WelsDestroySVCEncoder_ptr =
    reinterpret_cast<void (*)(ISVCEncoder *pEncoder)>(
      dlsym(module, WelsDestroySVCEncoder_name));
  if (!WelsDestroySVCEncoder_ptr)
    LogDlerror(WelsDestroySVCEncoder_name);
  const char WelsGetDecoderCapability_name[] = "WelsGetDecoderCapability";
  WelsGetDecoderCapability_ptr =
    reinterpret_cast<int (*)(SDecoderCapability *pDecCapability)>(
      dlsym(module, WelsGetDecoderCapability_name));
  if (!WelsGetDecoderCapability_ptr)
    LogDlerror(WelsGetDecoderCapability_name);
  const char WelsCreateDecoder_name[] = "WelsCreateDecoder";
  WelsCreateDecoder_ptr =
    reinterpret_cast<long (*)(ISVCDecoder **ppDecoder)>(
      dlsym(module, WelsCreateDecoder_name));
  if (!WelsCreateDecoder_ptr)
    LogDlerror(WelsCreateDecoder_name);
  const char WelsDestroyDecoder_name[] = "WelsDestroyDecoder";
  WelsDestroyDecoder_ptr =
    reinterpret_cast<void (*)(ISVCDecoder *pDecoder)>(
      dlsym(module, WelsDestroyDecoder_name));
  if (!WelsDestroyDecoder_ptr)
    LogDlerror(WelsDestroyDecoder_name);
  const char WelsGetCodecVersion_name[] = "WelsGetCodecVersion";
  WelsGetCodecVersion_ptr =
    reinterpret_cast<OpenH264Version (*)(void)>(
      dlsym(module, WelsGetCodecVersion_name));
  if (!WelsGetCodecVersion_ptr)
    LogDlerror(WelsGetCodecVersion_name);
  const char WelsGetCodecVersionEx_name[] = "WelsGetCodecVersionEx";
  WelsGetCodecVersionEx_ptr =
    reinterpret_cast<void (*)(OpenH264Version *pVersion)>(
      dlsym(module, WelsGetCodecVersionEx_name));
  if (!WelsGetCodecVersionEx_ptr)
    LogDlerror(WelsGetCodecVersionEx_name);
}

// Uninitialize the module stubs.  Reset pointers to nullptr.
void UninitializeOpenh264() {
  WelsCreateSVCEncoder_ptr = nullptr;
  WelsDestroySVCEncoder_ptr = nullptr;
  WelsGetDecoderCapability_ptr = nullptr;
  WelsCreateDecoder_ptr = nullptr;
  WelsDestroyDecoder_ptr = nullptr;
  WelsGetCodecVersion_ptr = nullptr;
  WelsGetCodecVersionEx_ptr = nullptr;
}

}  // namespace third_party_blink_renderer_modules_mediarecorder

namespace third_party_blink_renderer_modules_mediarecorder {
typedef std::map<StubModules, void*> StubHandleMap;
static void CloseLibraries(StubHandleMap* stub_handles) {
  for (StubHandleMap::const_iterator it = stub_handles->begin();
       it != stub_handles->end();
       ++it) {
    dlclose(it->second);
  }

  stub_handles->clear();
}
bool InitializeStubs(const StubPathMap& path_map) {
  StubHandleMap opened_libraries;
  for (int i = 0; i < kNumStubModules; ++i) {
    StubModules cur_module = static_cast<StubModules>(i);
    // If a module is missing, we fail.
    StubPathMap::const_iterator it = path_map.find(cur_module);
    if (it == path_map.end()) {
      CloseLibraries(&opened_libraries);
      return false;
    }

    // Otherwise, attempt to dlopen the library.
    const std::vector<std::string>& paths = it->second;
    bool module_opened = false;
    for (std::vector<std::string>::const_iterator dso_path = paths.begin();
         !module_opened && dso_path != paths.end();
         ++dso_path) {
      void* handle = dlopen(dso_path->c_str(), RTLD_LAZY);
      if (handle) {
        module_opened = true;
        opened_libraries[cur_module] = handle;
      } else {
        VLOG(1) << "dlopen(" << dso_path->c_str() << ") failed.";
        if (char *errstr = dlerror()) {
          VLOG(1) << "dlerror() says:\n" << errstr;
        } else {
          VLOG(1) << "dlerror() is nullptr";
        }

      }
    }

    if (!module_opened) {
      CloseLibraries(&opened_libraries);
      return false;
    }
  }

  // Initialize each module if we have not already failed.
  InitializeOpenh264(opened_libraries[kModuleOpenh264]);

  // Check that each module is initialized correctly.
  // Close all previously opened libraries on failure.
  if (!IsOpenh264Initialized()) {
    UninitializeOpenh264();
    CloseLibraries(&opened_libraries);
    return false;
  }

  return true;
}

}  // namespace third_party_blink_renderer_modules_mediarecorder
