// ui/gfx/mojom/native_handle_types.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "ui/gfx/mojom/native_handle_types.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/default_construct_traits.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "ui/gfx/mojom/native_handle_types.mojom-params-data.h"
#include "ui/gfx/mojom/native_handle_types.mojom-shared-message-ids.h"

#include "ui/gfx/mojom/native_handle_types.mojom-import-headers.h"
#include "ui/gfx/mojom/native_handle_types.mojom-test-utils.h"



namespace gfx {
namespace mojom {
NativePixmapPlane::NativePixmapPlane()
    : stride(),
      offset(),
      size(),
      buffer_handle() {}

NativePixmapPlane::NativePixmapPlane(
    uint32_t stride_in,
    uint64_t offset_in,
    uint64_t size_in,
    ::mojo::PlatformHandle buffer_handle_in)
    : stride(std::move(stride_in)),
      offset(std::move(offset_in)),
      size(std::move(size_in)),
      buffer_handle(std::move(buffer_handle_in)) {}

NativePixmapPlane::~NativePixmapPlane() = default;

void NativePixmapPlane::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "stride"), this->stride,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "offset"), this->offset,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "size"), this->size,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "buffer_handle"), this->buffer_handle,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::mojo::PlatformHandle>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool NativePixmapPlane::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
NativePixmapHandle::NativePixmapHandle()
    : planes(),
      modifier(),
      supports_zero_copy_webgpu_import() {}

NativePixmapHandle::NativePixmapHandle(
    std::vector<::gfx::NativePixmapPlane> planes_in,
    uint64_t modifier_in,
    bool supports_zero_copy_webgpu_import_in)
    : planes(std::move(planes_in)),
      modifier(std::move(modifier_in)),
      supports_zero_copy_webgpu_import(std::move(supports_zero_copy_webgpu_import_in)) {}

NativePixmapHandle::~NativePixmapHandle() = default;

void NativePixmapHandle::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "planes"), this->planes,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::vector<::gfx::NativePixmapPlane>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "modifier"), this->modifier,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "supports_zero_copy_webgpu_import"), this->supports_zero_copy_webgpu_import,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool NativePixmapHandle::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
GpuMemoryBufferPlatformHandle::GpuMemoryBufferPlatformHandle() : tag_(Tag::kSharedMemoryHandle) {
  data_.shared_memory_handle = new ::base::UnsafeSharedMemoryRegion;
}

GpuMemoryBufferPlatformHandle::~GpuMemoryBufferPlatformHandle() {
  DestroyActive();
}


void GpuMemoryBufferPlatformHandle::set_shared_memory_handle(
    ::base::UnsafeSharedMemoryRegion shared_memory_handle) {
  if (tag_ == Tag::kSharedMemoryHandle) {
    *(data_.shared_memory_handle) = std::move(shared_memory_handle);
  } else {
    DestroyActive();
    tag_ = Tag::kSharedMemoryHandle;
    data_.shared_memory_handle = new ::base::UnsafeSharedMemoryRegion(
        std::move(shared_memory_handle));
  }
}
void GpuMemoryBufferPlatformHandle::set_native_pixmap_handle(
    ::gfx::NativePixmapHandle native_pixmap_handle) {
  if (tag_ == Tag::kNativePixmapHandle) {
    *(data_.native_pixmap_handle) = std::move(native_pixmap_handle);
  } else {
    DestroyActive();
    tag_ = Tag::kNativePixmapHandle;
    data_.native_pixmap_handle = new ::gfx::NativePixmapHandle(
        std::move(native_pixmap_handle));
  }
}

void GpuMemoryBufferPlatformHandle::DestroyActive() {
  switch (tag_) {

    case Tag::kSharedMemoryHandle:

      delete data_.shared_memory_handle;
      break;
    case Tag::kNativePixmapHandle:

      delete data_.native_pixmap_handle;
      break;
  }
}

bool GpuMemoryBufferPlatformHandle::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context, false);
}


}  // namespace mojom
}  // namespace gfx


namespace mojo {


// static
bool StructTraits<::gfx::mojom::NativePixmapPlane::DataView, ::gfx::mojom::NativePixmapPlanePtr>::Read(
    ::gfx::mojom::NativePixmapPlane::DataView input,
    ::gfx::mojom::NativePixmapPlanePtr* output) {
  bool success = true;
  ::gfx::mojom::NativePixmapPlanePtr result(::gfx::mojom::NativePixmapPlane::New());
  
      if (success)
        result->stride = input.stride();
      if (success)
        result->offset = input.offset();
      if (success)
        result->size = input.size();
      if (success)
        result->buffer_handle = input.TakeBufferHandle();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::gfx::mojom::NativePixmapHandle::DataView, ::gfx::mojom::NativePixmapHandlePtr>::Read(
    ::gfx::mojom::NativePixmapHandle::DataView input,
    ::gfx::mojom::NativePixmapHandlePtr* output) {
  bool success = true;
  ::gfx::mojom::NativePixmapHandlePtr result(::gfx::mojom::NativePixmapHandle::New());
  
      if (success && !input.ReadPlanes(&result->planes))
        success = false;
      if (success)
        result->modifier = input.modifier();
      if (success)
        result->supports_zero_copy_webgpu_import = input.supports_zero_copy_webgpu_import();
  *output = std::move(result);
  return success;
}

// static
bool UnionTraits<::gfx::mojom::GpuMemoryBufferPlatformHandle::DataView, ::gfx::mojom::GpuMemoryBufferPlatformHandlePtr>::Read(
    ::gfx::mojom::GpuMemoryBufferPlatformHandle::DataView input,
    ::gfx::mojom::GpuMemoryBufferPlatformHandlePtr* output) {
  using UnionType = ::gfx::mojom::GpuMemoryBufferPlatformHandle;
  using Tag = UnionType::Tag;

  switch (input.tag()) {
    case Tag::kSharedMemoryHandle: {
      ::base::UnsafeSharedMemoryRegion result_shared_memory_handle;
      if (!input.ReadSharedMemoryHandle(&result_shared_memory_handle))
        return false;

      *output = UnionType::NewSharedMemoryHandle(
          std::move(result_shared_memory_handle));
      break;
    }
    case Tag::kNativePixmapHandle: {
      ::gfx::NativePixmapHandle result_native_pixmap_handle;
      if (!input.ReadNativePixmapHandle(&result_native_pixmap_handle))
        return false;

      *output = UnionType::NewNativePixmapHandle(
          std::move(result_native_pixmap_handle));
      break;
    }
    default:

      return false;
  }
  return true;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace gfx {
namespace mojom {




}  // namespace mojom
}  // namespace gfx


#if defined(__clang__)
#pragma clang diagnostic pop
#endif